define(function(require, exports, module) {

    var Http = require('U/http');
    var iosMagicStatus = _g.getLS('iosMagicStatus');

    var type = api.pageParam.type;

    var typeData = {
        '0': {
            content: '您只有3条免费浏览话题权限\n转发可获得多1条, 最多5条',
            btns: ['去转发', '去入会']
        },
        '1': {
            content: '您还有1条免费浏览话题权限\n转发可获得多1条浏览权限',
            btns: ['去转发', '去入会']
        },
        '2': {
            content: '您免费浏览话题权限已用完\n转发可获得多1条浏览权限',
            btns: ['去转发', '去入会']
        },
        '3': {
            content: '转发您还有1条免费浏览话题权限\n付费入会, 全场听学畅通无阻',
            btns: ['去转发', '去入会']
        },
        '4': {
            content: '您所有的免费浏览话题权限已用完\n付费入会, 全场听学畅通无阻',
            btns: ['现在就去']
        },
    }

    var author = new Vue({
        el: '#author',
        template: _g.getTemplate('account/author-main-V'),
        data: {
            content: 'aa',
            btns: ['a', 'b'],
        },
        created: function() {
            this.content = typeData[type].content;
            this.btns = typeData[type].btns;
        },
        methods: {
            onBtnTap: function(index) {
                if (type == 4) {
                    if (index == 0) {
                        this.openVip();
                    }
                } else {
                    if (index == 0) {
                        api.closeFrame({
                            name: 'account-author-frame'
                        });
                    } else if (index == 1) {
                        this.openVip();
                    }
                }
                api.closeFrame({
                    name: 'account-author-frame'
                });
            },
            onCloseTap: function() {
                api.closeFrame({
                    name: 'account-author-frame'
                });
            },
            openVip: function() {
                if(!iosMagicStatus) return;
                _g.openWin({
                    header: {
                        data: {
                            title: '会员',
                        }
                    },
                    name: 'me-vip',
                    url: '../me/vip.html',
                });
            }
        }
    });

    module.exports = {};

});
