define(function(require, exports, module) {

    var Http = require('U/http');
    var Vcode = require('U/vcode');

    var main = new Vue({
        el: '#main',
        template: _g.getTemplate('account/forget-main-V'),
        data: {
            tel : '',
            code : '',
            password : '',
            password2 : '',
            codeText: '',
        },
        created: function() {
            Vcode.init({
                onInit: this.onInit,
                onAction: this.onAction,
            });
        },
        methods: {
            onInit: function(nowText) {
                this.codeText = nowText;
            },
            onAction: function(nowText) {
                this.codeText = nowText;
            },
            onPostCode: function() {
                Vcode.start();
                this.vcode = Vcode.getRandom(6);

                var url = 'http://inter.smswang.net:7803/sms?action=send&account=000350&password=123456&mobile=' + this.tel + '&content=重置密码验证码：' + this.vcode + '【中国好父母】&extno=1069032239089338';

                api && api.ajax({
                    url: url,
                    method: 'get',
                    timeout: 60 * 20,
                    dataType: 'text',
                    returnAll: false,
                    data: {
                        values: {}
                    }
                }, function(ret, err) {
                    if (ret.indexOf('<message>OK</message>') > -1) {
                        _g.toast('验证码发送成功!');
                    } else {
                        _g.toast('验证码发送失败!');
                    }
                });
            },
            focus : function(event, item) {
                if (event.target.tagName !== 'SPAN') {
                    if (document.activeElement === item) {
                        return
                    }
                    item.focus();
                }
            },
            sendCode : function () {
                var phoneReg = /^1[0-9]{10}$/;
                if (!phoneReg.test(this.tel)) {
                    _g.toast('手机号码不正确!');
                    return;
                }
                if (Vcode.isAllow()) {
                    this.onPostCode();
                }
            },
            confirm : function () {
                if (this.tel == '') {
                    _g.toast('手机号不能为空');
                    return
                }
                if (this.code == '') {
                    _g.toast('验证码不能为空');
                    return
                }
                if (this.password == '') {
                    _g.toast('密码不能为空');
                    return
                }
                if (this.password2 == '') {
                    _g.toast('重新确认密码');
                    return
                }
                if (this.password != this.password2) {
                    _g.toast('输入的密码不一致');
                    return
                }
                if (this.code != this.vcode) {
                    _g.toast('验证码不正确');
                    return
                }
                postForget();
            }
        }
    });

    function postForget() {
        Http.ajax({
            data: {
                phone: main.tel,
                password: main.password,
            },
            isSync: true,
            url: '/api/user/forget',
            success: function(ret) {
                if (ret.code == 200) {
                    api && api.closeWin();
                }else {
                    _g.toast(ret.msg);
                }
            },
            error: function(err) {}
        });
    }

    module.exports = {};

});
