define(function(require, exports, module) {

    var Http = require('U/http');
    var iosMagicStatus = _g.getLS('iosMagicStatus');

    var wx = api.require('wx');
    var weibo = api.require('weibo');
    var qq = api.require('qq');

    var main = new Vue({
        el: '#main',
        template: _g.getTemplate('account/login-main-V'),
        data: {
            iosMagicStatus: iosMagicStatus,
            phone: '',
            password: '',
        },
        ready: function() {

        },
        methods: {
            onCloseTap: function() {
                api && api.closeWin();
            },
            onLoginTap: function() {
                if (this.phone === '') {
                    _g.toast('手机号不能为空');
                    return
                }
                if (this.password === '') {
                    _g.toast('密码不能为空');
                    return
                }
                this.postLogin();
            },
            onRegistTap: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '注册',
                        }
                    },
                    name: 'account-signUp',
                    url: '../account/signUp.html',
                    pageParam: {

                    }
                });
            },
            onForgetTap: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '忘记密码',
                        }
                    },
                    name: 'account-forget',
                    url: '../account/forget.html',
                    pageParam: {

                    }
                });
            },
            postLogin: function() {
                Http.ajax({
                    data: {
                        phone: this.phone,
                        password: this.password
                    },
                    isSync: true,
                    url: '/api/user/login',
                    success: function(ret) {
                        if (ret.code == 200) {
                            _g.setLS('UserInfo', ret.data.UserInfo);
                            _g.setLS('sessionID', ret.data.sessionID);
                            api.sendEvent({
                                name: 'global-login-success'
                            });
                            api && api.closeWin();
                        }
                    },
                    error: function(err) {}
                });
            }
        }
    });

    var module = new Vue({
        el: '#module',
        template: _g.getTemplate('account/login-module-V'),
        data: {
            show: false,
        },
        ready: function() {
            setTimeout(function() {
                var marginTop = window.innerHeight - ($('.ui-main').height() + $('.ui-module').height()) - 80;
                $('.ui-module').css('margin-top', marginTop + 'px');
                $('.ui-module').css('opacity', 1);
            }, 0);
        },
        methods: {
            onTap: function(type) {
                if (type == 'weixin') {
                    wx.isInstalled(function(ret, err) {
                        if (ret.installed) {
                            wxLogin();
                        } else {
                            alert('当前设备未安装微信客户端');
                        }
                    });
                    return
                }
                if (type == 'weibo') {
                    weibo.isInstalled(
                        function(ret) {
                            if (ret.status) {
                                weiboLogin();
                            } else {
                                alert('未安装新浪微博客户端');
                            }
                        }
                    );
                    return
                }
                if (type == 'qq') {
                    qq.installed(function(ret, err) {
                        if (ret.status) {
                            qqLogin();
                        } else {
                            api.alert({ msg: "未安装QQ客户端" });
                        }
                    });
                    return
                }
            }
        }
    });

    function wxLogin() {
        var access_token = {};
        var access_user = {};
        wx.auth(function(ret, err) {
            if (ret.status) {
                wx.getToken({
                    code: ret.code
                }, function(ret, err) {
                    if (ret.status) {
                        access_token = {
                            access_token: ret.accessToken,
                            expires_in: ret.expires,
                            refresh_token: ret.dynamicToken,
                            openid: ret.openId,
                            scope: 'snsapi_userinfo',
                        };
                        wx.getUserInfo({
                            accessToken: ret.accessToken,
                            openId: ret.openId
                        }, function(ret, err) {
                            if (ret.status) {
                                // status: true,      //布尔型；true||false
                                // openid: '',        //字符串类型；普通用户的标识，对当前开发者帐号唯一
                                // nickname: '',      //字符串类型；普通用户昵称
                                // sex: 1,            //数字类型；普通用户性别，1为男性，2为女性
                                // headimgurl: '',    //字符串类型；用户头像，最后一个数值代表正方形头像大小（有0、46、64、96、132数值可选，0代表640*640正方形头像），用户没有头像时该项为空
                                // privilege: [],     //数组类型；用户特权信息，如微信沃卡用户为（chinaunicom）
                                // unionid: ''        //字符串类型；用户统一标识。针对一个微信开放平台帐号下的应用，同一用户的unionid是唯一的。

                                // access_user = {
                                //     subscribe: 1,
                                //     openid: openid,
                                //     nickname: nickname,
                                //     sex: sex,
                                //     language: language,
                                //     city: city,
                                //     province: province,
                                //     country: country,
                                //     headimgurl: headimgurl,
                                //     subscribe_time: 1466581911,
                                //     remark: '',
                                //     groupid: 0,
                                //     tagid_list: [],
                                // };
                                access_user = ret;
                                postBind('weixin', access_user);
                            } else {
                                alert(err.code);
                            }
                        });
                    } else {
                        alert(err.code);
                    }
                });
            } else {
                alert(err.code);
            }
        });
    }

    function weiboLogin() {
        weibo.auth(function(ret, err) {
            if (ret.status) {
                // status: true,  //布尔型；true||false
                // token: '',     //字符串类型；从新浪微博服务器获取的 accessToken，接口调用凭证，传给 getUserInfo 接口获取用户信息
                // expire: '',    //字符串类型：token 有效期（时间戳）
                // userId: ''     //字符串类型；从新浪微博服务器获取的 userId，新浪微博分配的用户id，传给 getUserInfo 接口获取用户信息
                weibo.getUserInfo({
                    token: ret.token,
                    userId: ret.userId
                }, function(ret, err) {
                    if (ret.status) {
                        // status: true, //布尔型；true||false
                        // userInfo: {} //JSON对象；获取的用户信息（微博返回）
                        postBind('weibo', ret.userInfo);
                    } else {
                        alert(err.code);
                    }
                });
            } else {
                alert(err.code);
            }
        });
    }

    function qqLogin() {
        qq.login(function(ret, err) {
            if (ret.status) {
                // ret.openId
                // ret.accessToken
                var data = {
                    openid: ret.openId,
                    access_token: ret.accessToken,
                };
                qq.getUserInfo(function(ret, err) {
                    if (ret.status) {
                        // status: true, //布尔型；true||false
                        // info: {} //JSON对象；获取的用户信息（qq返回）
                        data = $.extend(true, data, ret.info);
                        postBind('qq', data);
                    } else {
                        api.alert({ msg: err.msg });
                    }
                });
            } else {
                api.alert({ msg: err.msg });
            }
        });
    }

    function postBind(type, data) {
        Http.ajax({
            data: {
                type: type,
                data: data
            },
            isSync: true,
            url: '/api/user/login_bind',
            success: function(ret) {
                if (ret.code == 200) {
                    _g.setLS('UserInfo', ret.data.UserInfo);
                    _g.setLS('sessionID', ret.data.sessionID);
                    api.sendEvent({
                        name: 'global-login-success'
                    });
                    api && api.closeWin();
                }
            },
            error: function(err) {}
        });
    }

    api.addEventListener({
        name: 'viewappear'
    }, function(ret, err) {
        _g.closeWins(['money-home-win']);
    });

    module.exports = {};

});
