define(function(require, exports, module) {

    var Http = require('U/http');
    var Vcode = require('U/vcode');
    var iosMagicStatus = _g.getLS('iosMagicStatus');

    var main = new Vue({
        el: '#main',
        template: _g.getTemplate('account/signUp-main-V'),
        data: {
            iosMagicStatus: iosMagicStatus,
            tel: '',
            code: '',
            nick: '',
            password: '',
            password2: '',
            codeText: '',
        },
        created: function() {
            Vcode.init({
                onInit: this.onInit,
                onAction: this.onAction,
            });
        },
        methods: {
            onProtocolTap: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '会员服务协议',
                        }
                    },
                    name: 'setting-protocol',
                    url: '../setting/protocol.html',
                });
            },
            onInit: function(nowText) {
                this.codeText = nowText;
            },
            onAction: function(nowText) {
                this.codeText = nowText;
            },
            onPostCode: function() {
                Vcode.start();
                this.vcode = Vcode.getRandom(6);
                
                var url = 'http://inter.smswang.net:7803/sms?action=send&account=000350&password=123456&mobile=' + this.tel + '&content=注册账号验证码：' + this.vcode + '【中国好父母】&extno=1069032239089338';

                api && api.ajax({
                    url: url,
                    method: 'get',
                    timeout: 60 * 20,
                    dataType: 'text',
                    returnAll: false,
                    data: {
                        values: {}
                    }
                }, function(ret, err) {
                    if (ret.indexOf('<message>OK</message>') > -1) {
                        _g.toast('验证码发送成功!');
                    } else {
                        _g.toast('验证码发送失败!');
                    }
                });
            },
            focus: function(event, item) {
                if (event.target.tagName !== 'SPAN') {
                    if (document.activeElement === item) {
                        return
                    }
                    item.focus();
                }
            },
            sendCode: function() {
                var phoneReg = /^1[0-9]{10}$/;
                if (!phoneReg.test(this.tel)) {
                    _g.toast('手机号码不正确!');
                    return;
                }
                if (Vcode.isAllow()) {
                    this.onPostCode();
                }
            },
            confirm: function() {
                if (this.tel == '') {
                    _g.toast('手机号不能为空');
                    return
                }
                if (this.code == '') {
                    _g.toast('验证码不能为空');
                    return
                }
                if (this.nick == '') {
                    _g.toast('姓名不能为空');
                    return
                }
                if (this.password == '') {
                    _g.toast('密码不能为空');
                    return
                }
                if (this.password2 == '') {
                    _g.toast('重新确认密码');
                    return
                }
                if (this.password != this.password2) {
                    _g.toast('输入的密码不一致');
                    return
                }
                if (this.code != this.vcode) {
                    _g.toast('验证码不正确');
                    return
                }
                postRegist();
            }
        }
    });

    function postRegist() {
        Http.ajax({
            data: {
                phone: main.tel,
                userName: main.nick,
                password: main.password,
            },
            isSync: true,
            url: '/api/user/regist',
            success: function(ret) {
                if (ret.code == 200) {
                    _g.setLS('UserInfo', ret.data.UserInfo);
                    _g.setLS('sessionID', ret.data.sessionID);
                    api.sendEvent({
                        name: 'global-login-success'
                    });
                    openMainPage();
                    api.alert({
                        title: '提示',
                        msg: '注册成功!'
                    });
                    setTimeout(function(){
                        api.closeWin({
                            name: 'account-login-win',
                            animation: { type: 'none' }
                        });
                        api.closeWin({
                            name: 'account-signUp-win',
                            animation: { type: 'none' }
                        });
                    }, 500);
                    // api && api.closeWin();
                } else {
                    _g.toast(ret.msg);
                }
            },
            error: function(err) {}
        });
    }

    function openMainPage() {
        api && api.openWin({
            name: 'main-index-win',
            url: '../main/index.html',
            bounces: false,
            slidBackEnabled: false,
            pageParam: { key: 'value' },
            animation: { type: 'fade' }
        });
    }

    module.exports = {};

});
