define(function(require, exports, module) {

    var extra = api && api.pageParam.extra;
    var iosMagicStatus = _g.getLS('iosMagicStatus');

    var book = new Vue({
        el: '#book',
        template: _g.getTemplate('book/index-book-V'),
        data: {
            image: extra.cover,
            title: extra.title,
            desc: extra.desc,
            vip: false,
            iosMagicStatus: iosMagicStatus,
        },
        created: function() {
            var UserInfo = _g.getLS('UserInfo');
            if (UserInfo) this.vip = !!UserInfo.isVip;
        },
        methods: {
            onCloseTap: function() {
                api.closeWin()
            },
            openDetail: function(tag) {
                _g.openWin({
                    header: {
                        data: {
                            title: '详情',
                        }
                    },
                    name: 'read-detail',
                    url: '../read/detail.html',
                    bounces: false,
                    pageParam: {
                        id: extra.id,
                        tag: tag
                    }
                });
            },
            openRegistVip: function() {
                if (!iosMagicStatus) return;
                _g.openWin({
                    header: {
                        data: {
                            title: '会员',
                        }
                    },
                    name: 'me-vip',
                    url: '../me/vip.html',
                });
            },
            onBuyTap: function() {
                if (_g.checkUser()) {
                    this.openRegistVip();
                }
            },
            onItemTap: function(tag) {
                var self = this;
                var type = _g.checkAuthor();
                var UserInfo = _g.getLS('UserInfo');

                if (type == 'vip') {
                    self.openDetail(tag);
                } else if (type == 'free') {
                    if (_.indexOf(UserInfo.freeHistory, extra.id) == -1) {
                        UserInfo.freeHistory.push(extra.id);
                    }
                    _g.setLS('UserInfo', UserInfo);
                    self.openDetail(tag);
                } else if (type == 'max') {
                    if (_.indexOf(UserInfo.freeHistory, extra.id) > -1) {
                        self.openDetail(tag);
                    } else {
                        self.openRegistVip();
                    }
                }
            }
        }
    });

    module.exports = {};

});
