define(function(require, exports, module) {
    var index = api && api.pageParam.index;
    var topicId = api && api.pageParam.topicId;
    var Http = require('U/http');
    var Tips = require('U/tips');
    var commentList = new Vue({
        el: '#commentList',
        template: _g.getTemplate('comment/index-list-V'),
        data: {
            comment: [{
                title: '热评',
                show: 0,
                list: [{
                    id: 0,
                    photo: 'http://usr.im/100x100',
                    title: '我是专家',
                    content: '测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>',
                    like: 0,
                    liked: false,
                }, {
                    id: 0,
                    photo: 'http://usr.im/100x100',
                    title: '我是专家',
                    content: '测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>',
                    like: 2,
                    liked: true,
                }]
            }, {
                title: '最新',
                show: 0,
                list: [{
                    id: 0,
                    photo: 'http://usr.im/100x100',
                    title: '我是专家',
                    content: '测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>',
                    like: 0,
                    liked: false,
                }, {
                    id: 0,
                    photo: 'http://usr.im/100x100',
                    title: '我是专家',
                    content: '测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>测试测试<br>测试<br>测试<br>',
                    like: 0,
                    liked: false,
                }]
            }]
        },
        created: function() {
            this.comment[0].list = [];
            this.comment[1].list = [];
            this.comment[0].show = 0;
            this.comment[1].show = 0;
        },
        methods: {
            like: function(item) {
                postCommentGreat(item.id, item.liked ? 'greatCancel' : 'great', item);
            }
        }
    });

    var chatBox = new Vue({
        el: '#chatBox',
        template: _g.getTemplate('comment/index-chatBox-V'),
        data: {
            text: ''
        },
        methods: {
            onBackTap: function() {
                api.closeWin();
            },
            onSendTap: function() {
                this.onEnter();
                this.text = '';
            },
            onEnter: function() {
                if (this.text == '') {
                    _g.toast('请输入评论内容', 2000, this.focus ? 'top' : 'middle');
                } else {
                    postComment(this.text);
                }
            },
            onFocus: function() {
                this.focus = true;

                // $('body').css('overflow', 'hidden');
                // $('.ui-chatBox__body').css({
                //     'position': 'static',
                //     'bottom': 0
                // })
            },
            onBlur: function() {
                this.focus = false;
                // $('body').css('overflow', 'auto');
                // $('.ui-chatBox__body').css({
                //     'position': 'fixed',
                //     'bottom': 0
                // })
            }
        }
    });

    function postCommentGreat(commentId, type, item) {
        Http.ajax({
            data: {
                commentId: commentId,
            },
            isSync: true,
            url: '/api/comment/' + type,
            success: function(ret) {
                if (ret.code == 200) {
                    getData();
                    // item.liked = !item.liked;
                    // item.liked ? (item.like++) : (item.like--);
                }
            },
            error: function(err) {}
        });
    }

    function postComment(content) {
        Http.ajax({
            data: {
                topicId: topicId,
                content: content
            },
            isSync: true,
            url: '/api/comment/add',
            success: function(ret) {
                if (ret.code == 200) {
                    $('.ui-chatBox__input').blur();
                    if(ret.data){
                        Tips.show({
                            title: '评论成功',
                            subtitle: '+5积分'
                        });
                    }
                    getData();
                    api.sendEvent({
                        name: 'read-list-update-one',
                        extra: {
                            index: index
                        }
                    });
                }
            },
            error: function(err) {}
        });
    }

    function getData() {
        Http.ajax({
            data: {
                topicId: topicId
            },
            url: '/api/comment/list',
            success: function(ret) {
                if (ret.code == 200) {
                    setTimeout(function() {
                        commentList.comment[0].show = ret.data.hot.length > 0 ? 1 : 0;
                        commentList.comment[0].list = _.map(ret.data.hot, function(item) {
                            return {
                                id: item.id,
                                photo: item.userInfo.avatar,
                                title: item.userInfo.userName,
                                content: item.content,
                                like: item.greatNum,
                                liked: item.great,
                            }
                        });
                        commentList.comment[1].show = ret.data.new.length > 0 ? 1 : 0;
                        commentList.comment[1].list = _.map(ret.data.new, function(item) {
                            return {
                                id: item.id,
                                photo: item.userInfo.avatar,
                                title: item.userInfo.userName,
                                content: item.content,
                                like: item.greatNum,
                                liked: item.great,
                            }
                        });
                    }, 0);
                }
            },
            error: function(err) {}
        });
    }

    getData();

    module.exports = {};

});
