define(function(require, exports, module) {
    var Tips = require('U/tips');
    var index = 1;

    var downloadList = new Vue({
        el: '#downloadList',
        template: _g.getTemplate('download/index-list-V'),
        data: {
            used: '10.0M',
            available: '48888.9M',
            isDone: 1,
            doneList: [{
                id: 0,
                tag: 1,
                title: '孩子犯错孩子犯错孩子犯错孩子犯错4',
                size: '1.1M',
                image: 'http://usr.im/100x100',
                path: 'xxx/xxx/xx.mp4'
            }, {
                id: 0,
                tag: 1,
                title: '孩子犯错孩子犯错孩子犯错孩子犯错5',
                size: '1.1M',
                image: 'http://usr.im/100x100',
                path: 'xxx/xxx/xx.mp4'
            }, {
                id: 0,
                tag: 1,
                title: '孩子犯错孩子犯错孩子犯错孩子犯错6',
                size: '1.12M',
                image: 'http://usr.im/100x100',
                path: 'xxx/xxx/xx.mp4'
            }],
            downloadList: [{
                id: 0,
                tag: 1,
                title: '孩子犯错孩子犯错孩子犯错孩子犯错1',
                size: '1.1M',
                image: 'http://usr.im/100x100',
                path: 'xxx/xxx/xx.mp4'
            }, {
                id: 0,
                tag: 1,
                title: '孩子犯错孩子犯错孩子犯错孩子犯错2',
                size: '1.1M',
                image: 'http://usr.im/100x100',
                path: 'xxx/xxx/xx.mp4'
            }, {
                id: 0,
                tag: 1,
                title: '孩子犯错孩子犯错孩子犯错孩子犯错3',
                size: '1.12M',
                image: 'http://usr.im/100x100',
                path: 'xxx/xxx/xx.mp4'
            }]
        },
        created: function() {
            this.doneList = [];
            this.downloadList = [];
        },
        methods: {
            onDetailTap: function(item, index, event) {
                var action = $(event.target).attr('data-action');
                if (action == 'delete') {
                    if(this.isDone){
                        downloadList.doneList.splice(index, 1);
                    }else {
                        // downloadList.downloadList.splice(index, 1);
                        _g.toast('正在下载中, 不能执行该操作!');
                    }
                    return;
                }

                _g.openWin({
                    header: {
                        data: {
                            title: '详情',
                        }
                    },
                    name: 'read-detail',
                    url: '../read/detail.html',
                    bounces: false,
                    pageParam: {
                        id: item.id,
                        tag: item.tag,
                        path: item.path
                    }
                });
            }
        }
    });

    api.getFreeDiskSpace(function(ret, err) {
        var size = (ret.size / (1024 * 1024 * 1024)).toFixed(1) + 'G';
        downloadList.available = size;
    });

    var getData = function(index) {
        $('.ui-header__title').css('padding', '0px');
        var downloadHistory = _g.getLS('download');
        var useSize = 0;
        _.each(downloadHistory, function(n, i) {
            var listData = {};
            if (index == 1) {
                if (n.state == 1) {
                    listData = {
                        id: n.id,
                        tag: n.tag,
                        title: n.title,
                        size: (n.size / (1024 * 1024)).toFixed(1) + 'MB',
                        image: n.cover,
                        path: n.path
                    }
                    downloadList.doneList.push(listData);
                }
            } else {
                if (n.state != 1) {
                    listData = {
                        id: n.id,
                        tag: n.tag,
                        title: n.title,
                        size: (n.size / (1024 * 1024)).toFixed(1) + 'MB',
                        image: n.cover,
                        path: n.path
                    }
                    downloadList.downloadList.push(listData);
                }
            }
        });
        getSize();
    }

    var getSize = function() {
        var downloadHistory = _g.getLS('download');
        var useSize = 0;
        if (downloadHistory == null) {
            downloadList.used = useSize + 'MB';
            return;
        } else {
            _.each(downloadHistory, function(n, i) {
                useSize += n.size;
            });
        }
        downloadList.used = (useSize / (1024 * 1024)).toFixed(1) + 'MB';
    }

    function initListTool() {
        var hammer = new Hammer($('.ui-list')[0], {});
        var $hammer_msg = null;
        var toolbar_width = 0;
        var hammer_allow = true;
        var hammer_end = false;
        hammer.on('panstart', function(ev) {
            $hammer_msg = $(ev.target).closest('.ui-list__item');
            toolbar_width = $hammer_msg.find('.ui-msgToolbar').width();
            hammer_end = false;
        });
        hammer.on('panmove', function(ev) {
            if (!hammer_allow) return;
            if ($hammer_msg.hasClass('is-active')) {
                if (ev.deltaX >= 0) {
                    $hammer_msg.find('.ui-list__itemBody').css({
                        'transition-duration': '0.2s',
                        '-webkit-transform': 'translate3d(0,0,0)'
                    });
                    hammer_allow = false;
                    setTimeout(function() {
                        $hammer_msg.removeClass('is-active');
                        hammer_end = true;
                    }, 200);
                }
            } else {
                if (ev.deltaX >= 20) {
                    ev.deltaX = 20;
                } else {
                    if (ev.deltaX < -toolbar_width - 20) {
                        ev.deltaX = -toolbar_width - 20;
                    }
                }
                $hammer_msg.find('.ui-list__itemBody').css({
                    '-webkit-transform': 'translate3d(' + ev.deltaX + 'px,0,0)',
                    'transition-duration': '0s'
                });
            }
        });
        hammer.on('panend', function(ev) {
            if (hammer_end) {
                hammer_allow = true;
                return;
            }
            if (ev.deltaX >= 0) {
                $hammer_msg.find('.ui-list__itemBody').css({
                    'transition-duration': '0.2s',
                    '-webkit-transform': 'translate3d(0,0,0)'
                });
                hammer_allow = false;
                setTimeout(function() {
                    $hammer_msg.removeClass('is-active');
                    hammer_allow = true;
                }, 200);

            } else if (ev.deltaX > -toolbar_width * 0.3 && ev.deltaX < 0) {
                $hammer_msg.find('.ui-list__itemBody').css({
                    'transition-duration': '0.2s',
                    '-webkit-transform': 'translate3d(0,0,0)'
                });
                hammer_allow = false;
                setTimeout(function() {
                    $hammer_msg.removeClass('is-active');
                    hammer_allow = true;
                }, 200);
            } else if (ev.deltaX <= -toolbar_width * 0.3) {
                $hammer_msg.find('.ui-list__itemBody').css({
                    'transition-duration': '0.2s',
                    '-webkit-transform': 'translate3d(' + (-toolbar_width) + 'px,0,0)'
                });
                hammer_allow = false;
                setTimeout(function() {
                    $hammer_msg.addClass('is-active');
                    hammer_allow = true;
                }, 200);
            }
        });
        hammer.on('pancancel panup', function(ev) {
            if (hammer_end) {
                hammer_allow = true;
                hammer_end = false;
                return;
            }
            if (ev.deltaX >= 0) {
                $hammer_msg.find('.ui-list__itemBody').css({
                    'transition-duration': '0.2s',
                    '-webkit-transform': 'translate3d(0,0,0)'
                });
                hammer_allow = false;
                setTimeout(function() {
                    $hammer_msg.removeClass('is-active');
                    hammer_allow = true;
                }, 200);

            } else if (ev.deltaX > -toolbar_width * 0.3 && ev.deltaX < 0) {
                $hammer_msg.find('.ui-list__itemBody').css({
                    'transition-duration': '0.2s',
                    '-webkit-transform': 'translate3d(0,0,0)'
                });
                hammer_allow = false;
                setTimeout(function() {
                    $hammer_msg.removeClass('is-active');
                    hammer_allow = true;
                }, 200);
            } else if (ev.deltaX <= -toolbar_width * 0.3) {
                $hammer_msg.find('.ui-list__itemBody').css({
                    'transition-duration': '0.2s',
                    '-webkit-transform': 'translate3d(' + (-toolbar_width) + 'px,0,0)'
                });
                hammer_allow = false;
                setTimeout(function() {
                    $hammer_msg.addClass('is-active');
                    hammer_allow = true;
                }, 200);
            }
        });
    }

    getData(index);
    setTimeout(function() {
        initListTool();
    }, 500);

    api && api.addEventListener({
        name: 'refresh-donelist'
    }, function(ret, err) {
        index = ret.value.index;
        if (index == 1) {
            downloadList.isDone = 1;
            downloadList.doneList = [];
            getData(index);
        } else {
            downloadList.isDone = 0;
            downloadList.downloadList = [];
            getData(index);
        }

    });
    api && api.addEventListener({
        name: 'refresh-downloadlist'
    }, function(ret, err) {
        downloadList.downloadList = [];
        downloadList.doneList = [];
        getData(0);
        getData(1);
    });
    api && api.addEventListener({
        name: 'delete-success'
    }, function(ret, err) {
        downloadList.doneList = [];
        downloadList.downloadList = [];
        getData(0);
        getData(1);
        getSize();
        Tips.show({
            title: '列表数据已清空',
        });
    });
    module.exports = {};

});
