define(function(require, exports, module) {

    var Http = require('U/http');
    var iosMagicStatus = _g.getLS('iosMagicStatus');

    var listenList = new Vue({
        el: '#listenList',
        template: _g.getTemplate('listen/index-list-V'),
        data: {
            active: -1,
            itemHeight: window.innerHeight * 0.5 + 'px',
            list: [{
                id: 0,
                title: '',
                photo: 'http://usr.im/400x400',
                active: false,
            }]
        },
        created: function() {
            this.list = [];
            window.nowPage = 1;
            getData(window.nowPage);
        },
        methods: {
            onPhotoTap: function(index) {
                _.each(this.list, function(item, itemIndex) {
                    if (itemIndex != index) item.active = false;
                });
                this.list[index].active = !this.list[index].active;
            },
            onItemTap: function(index, event) {
                if (this.list[index].active) return;
                if (event.target.classList.contains('ui-list__photo')) return;
                this.list[index].active = !this.list[index].active;
            },
            openDetail: function(tag, index) {
                _g.openWin({
                    header: {
                        data: {
                            title: this.list[index].title,
                        }
                    },
                    name: 'read-detail',
                    url: '../read/detail.html',
                    bounces: false,
                    pageParam: {
                        id: this.list[index].id,
                        tag: tag
                    }
                });
            },
            openRegistVip: function() {
                if(!iosMagicStatus) return;
                _g.openWin({
                    header: {
                        data: {
                            title: '会员',
                        }
                    },
                    name: 'me-vip',
                    url: '../me/vip.html',
                    pageParam: {

                    }
                });
            },
            onBtnTap: function(tag, index) {
                var self = this;
                var type = _g.checkAuthor();
                var UserInfo = _g.getLS('UserInfo');

                if(type == 'vip'){
                    self.openDetail(tag, index);
                }else if(type == 'free'){
                    if(_.indexOf(UserInfo.freeHistory, this.list[index].id) == -1){
                        UserInfo.freeHistory.push(this.list[index].id);
                    } 
                    _g.setLS('UserInfo', UserInfo);
                    self.openDetail(tag, index);
                }else if(type == 'max'){
                    if(_.indexOf(UserInfo.freeHistory, this.list[index].id) > -1){
                        self.openDetail(tag, index);
                    }else{
                        self.openRegistVip();    
                    }
                }

            }
        },
    });

    function getData(page) {
        Http.ajax({
            data: {
                type: 2,
                page: page
            },
            isSync: true,
            url: '/api/topic/list',
            success: function(ret) {
                if (ret.code == 200) {
                    setTimeout(function() {
                        
                        var list = [];

                        if (ret.data.length == 0) {
                            _g.toast('没有更多了~');
                            window.isNoMore = true;
                        }

                        list = _.map(ret.data, function(item) {
                            return {
                                active: false,
                                id: item.id,
                                photo: item.photo,
                                cover: item.cover,
                                title: item.title,
                            }
                        });

                        if (window.nowPage == 1) {
                            listenList.list = list;
                        } else {
                            listenList.list = listenList.list.concat(list);
                        }

                    }, 0);
                }
            },
            error: function(err) {}
        });
    }
    _g.setPullDownRefresh(function() {
        window.nowPage = 1;
        getData(window.nowPage);
    });

    _g.setLoadmore(function() {
        window.nowPage++;
        getData(window.nowPage);
    });

    module.exports = {};

});
