define(function(require, exports, module) {

    var mainFrameList = [
        'read',
        'listen',
        'me'
    ];

    var header = new Vue({
        el: '#header',
        template: _g.getTemplate('main/index-header-V'),
        data: {
            active: 0,
        },
        methods: {
            onSearchTap: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '搜索',
                            rightText: '取消',
                            isSearchInput: false,
                            searchText: '',
                        },
                        template: '../html/main/search-header-V'
                    },
                    name: 'search-index',
                    url: '../search/index.html',
                    pageParam: {

                    }
                });
            },
        }
    });

    var footer = new Vue({
        el: '#footer',
        template: _g.getTemplate('main/index-footer-V'),
        data: {
            active: 0,
            list: [{
                title: '悦读',
                tag: 'read'
            }, {
                title: '听学',
                tag: 'listen'
            }, {
                title: '我的',
                tag: 'me'
            }]
        },
        methods: {
            onItemTap: function(index) {
                if (this.active == index) return;
                header.active = index;
                this.active = index;
                setFrameGroupIndex(index);
                if (index == 2) {
                    api.sendEvent({
                        name: 'me-info-getData',
                    });
                }
            },
        }
    });

    setTimeout(function() {
        openFrameGroup()
    }, 0);

    function openFrameGroup() {
        var headerHeight = $('#header').offset().height;
        var footerHeight = $('#footer').height();
        var windowHeight = window.innerHeight;

        api && api.openFrameGroup({
            name: 'main-group',
            scrollEnabled: false,
            rect: {
                x: 0,
                y: headerHeight,
                w: 'auto',
                h: windowHeight - headerHeight - footerHeight
            },
            index: 0,
            preload: 2,
            frames: [{
                name: 'main-group-read',
                url: '../read/index.html',
                bounces: true,
                bgColor: '#fffdea',
            }, {
                name: 'main-group-listen',
                url: '../listen/index.html',
                bgColor: '#fffdea',
            }, {
                name: 'main-group-me',
                url: '../me/index.html',
                bounces: false,
                bgColor: '#fffdea',
                vScrollBarEnabled: false,
                hScrollBarEnabled: false,
            }, ]
        }, function(ret, err) {
            header.active = ret.index;
            footer.active = ret.index;
            setTimeout(function() {
                api && api.removeLaunchView();
            }, 2000);
            return;
            // 判断是否第一次启动APP
            if (_g.getLS('isFirstStart') == 'true') {
                api && api.sendFrameToBack({
                    from: 'index-index-frame'
                });
                openLeadingPage();
            } else {
                api && api.removeLaunchView();
            }
            showFrame(ret.index);
        });
    }

    function setFrameGroupIndex(index) {
        api && api.setFrameGroupIndex({
            name: 'main-group',
            index: index,
            scroll: false
        });
    }

    function showFrame(index) {
        _.each(mainFrameList, function(item, i) {
            if (i == index) {
                api && api.setFrameAttr({
                    name: item + '-index-frame',
                    hidden: false
                });
            } else {
                api && api.setFrameAttr({
                    name: item + '-index-frame',
                    hidden: true
                });
            }
        });
    }

    function openLeadingPage() {
        api && api.openFrame({
            name: 'leading-pages-frame',
            url: '../leading/index.html',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false
        });
        _g.setLS('isFirstStart', 'false');
    }

    // 监听安卓返回按钮事件
    api && api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        api.closeWidget();
    });

    module.exports = {};

});
