define(function(require, exports, module) {

    var Http = require('U/http');
    var type = api.pageParam.type;

    var edit = new Vue({
        el: '#edit',
        template: _g.getTemplate('me/edit-V'),
        data: {
            text: ''
        },
        created: function() {
            var UserInfo = _g.getLS('UserInfo');
            this.text = UserInfo[type];
        },
        methods: {
            onSave: function(){
                if(this.text == ''){
                    _g.toast('内容不能为空!');
                    return;
                }
                Http.ajax({
                    data: {
                        type: type,
                        value: this.text
                    },
                    isSync: true,
                    url: '/api/user/update',
                    success: function(ret) {
                        if (ret.code == 200) {
                            var UserInfo = _g.getLS('UserInfo');
                            UserInfo[type] = edit.text;
                            _g.setLS('UserInfo', UserInfo);
                            api.sendEvent({
                                name: 'me-info-update',
                            });
                            api.alert({
                                title: '提示',
                                msg: '更新成功',
                            }, function(ret, err) {
                                api.closeWin();
                            });
                        }
                    },
                    error: function(err) {}
                })
            }
        }
    });

    api.addEventListener({
        name: 'me-edit-save'
    }, function(ret, err) {
        edit.onSave();
    });

    module.exports = {};

});
