define(function(require, exports, module) {

    var Http = require('U/http');
    var iosMagicStatus = _g.getLS('iosMagicStatus');

    var userInfo = new Vue({
        el: '#userInfo',
        template: _g.getTemplate('me/index-info-V'),
        data: {
            iosMagicStatus: iosMagicStatus,
            signIn: false,
            avatar: '',
            nickname: '',
            count: 0,
            money: 0,
            vip: false,
            hasSignIn: false,
        },
        methods: {
            onAvatarTap: function() {
                if (_g.checkUser()) {
                    _g.openWin({
                        header: {
                            data: {
                                title: '个人信息',
                            }
                        },
                        name: 'me-info',
                        url: '../me/info.html',
                        pageParam: {

                        }
                    });
                }
            },
            onSettingTap: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '设置',
                        }
                    },
                    name: 'setting-index',
                    url: '../setting/index.html',
                    pageParam: {

                    }
                });
            },
            onSignInTap: function() {
                if (this.hasSignIn) return;
                this.postSignIn();
            },
            postSignIn: function() {
                Http.ajax({
                    data: {},
                    url: '/api/sign/add',
                    success: function(ret) {
                        if (ret.code == 200) {
                            getData();
                            userInfo.hasSignIn = true;
                            _g.toast('签到成功');
                        } else if (ret.code == 50103) {
                            userInfo.hasSignIn = true;
                        }
                    },
                    error: function(err) {}
                });
            }
        }
    });

    if (_g.getLS('sessionID')) {
        getData();
    }

    function updateUserInfo() {
        var UserInfo = _g.getLS('UserInfo');
        userInfo.signIn = true;
        userInfo.avatar = UserInfo.avatar;
        userInfo.nickname = UserInfo.userName;
        userInfo.count = UserInfo.integral;
        userInfo.money = UserInfo.wallet;
        userInfo.vip = UserInfo.vip;
        userInfo.hasSignIn = !!UserInfo.isSign;
        // 审核判断
        if (_g.getLS('iosMagicStatus')) {
            selectList.list = [{
                    title: '会员充值',
                    tag: 'is-vip',
                    point: true,
                }, {
                    title: '我的二维码',
                    tag: 'is-qrcode',
                }, {
                    title: '我的钱包',
                    tag: 'is-money',
                }, {
                    title: '下载听学',
                    tag: 'is-download',
                }, {
                    title: '收藏听学',
                    tag: 'is-collect',
                }, {
                    title: '父母提问',
                    tag: 'is-parent',
                }
            ];
        }
    }

    function clearUserInfo() {
        userInfo.signIn = false;
        userInfo.avatar = '';
        userInfo.nickname = '';
        userInfo.count = 0;
        userInfo.money = 0;
        userInfo.vip = false;
        userInfo.hasSignIn = false;
    }

    var selectList = new Vue({
        el: '#selectList',
        template: _g.getTemplate('me/index-list-V'),
        data: {
            list: [{
                title: '我的二维码',
                tag: 'is-qrcode',
            }, {
                title: '收藏听学',
                tag: 'is-collect',
            }, {
                title: '父母提问',
                tag: 'is-parent',
            }]
        },
        created: function() {
            // 通过审核, 显示部分入口
            if (iosMagicStatus) {
                this.list = [{
                        title: '会员充值',
                        tag: 'is-vip',
                        point: true,
                    }, {
                        title: '我的二维码',
                        tag: 'is-qrcode',
                    }, {
                        title: '我的钱包',
                        tag: 'is-money',
                    }, {
                        title: '下载听学',
                        tag: 'is-download',
                    }, {
                        title: '收藏听学',
                        tag: 'is-collect',
                    }, {
                        title: '父母提问',
                        tag: 'is-parent',
                    }
                    // , {
                    //     title: '积分商城',
                    //     tag: 'is-business',
                    // }
                    // , {
                    //     title: '线下课程',
                    //     tag: 'is-course',
                    // }
                ];
            }
        },
        methods: {
            onItemTap: function(index) {
                if (_g.checkUser()) {
                    this.switchTag(this.list[index].tag);
                }
            },
            switchTag: function(tag) {
                switch (tag) {
                    case 'is-vip':
                        this.openVip();
                        // if(!_g.getLS('UserInfo').isVip) this.openVip();
                        // else _g.toast('您已经成为会员了!');
                        break;
                    case 'is-money':
                        this.openMoney();
                        break;
                    case 'is-collect':
                        this.openCollect();
                        break;
                    case 'is-download':
                        this.openDownload();
                        break;
                    case 'is-business':
                        this.openBusiness();
                        break;
                    case 'is-parent':
                        this.openParent();
                        break;
                    case 'is-course':
                        this.openCourse();
                        break;
                    case 'is-qrcode':
                        this.openQrcode();
                        break;
                }
            },
            openQrcode: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '推广大使二维码',
                            rightText: '保存'
                        }
                    },
                    name: 'me-qrcode',
                    url: '../me/qrcode.html',
                    bounces: false,
                    pageParam: {

                    }
                });
            },
            openVip: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '会员',
                        }
                    },
                    name: 'me-vip',
                    url: '../me/vip.html',
                    pageParam: {

                    }
                });
            },
            openMoney: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '钱包',
                            // rightText: '明细',
                        }
                    },
                    name: 'money-home',
                    url: '../money/home.html',
                    pageParam: {

                    }
                });
            },
            openCollect: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '收藏',
                        }
                    },
                    name: 'favorite-index',
                    url: '../favorite/index.html',
                    pageParam: {

                    }
                });
            },
            openDownload: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '下载',
                            rightText: '清空',
                            isDown: false,
                            isDone: true,
                        },
                        template: '../html/main/download-header-V'
                    },
                    name: 'download-index',
                    url: '../download/index.html',
                    pageParam: {

                    }
                });
            },
            openBusiness: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '商城',
                        }
                    },
                    name: 'business-index',
                    url: '../business/index.html',
                    pageParam: {

                    }
                });
            },
            openParent: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '父母提问',
                        }
                    },
                    name: 'question-index',
                    url: '../question/index.html',
                    pageParam: {

                    }
                });
            },
            openCourse: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '线下课程',
                        }
                    },
                    name: 'course-index',
                    url: '../course/index.html',
                    pageParam: {

                    }
                });
            },

        }
    });

    function getData() {
        Http.ajax({
            data: {},
            url: '/api/user/info',
            success: function(ret) {
                if (ret.code == 200) {
                    _g.setLS('UserInfo', ret.data);
                    updateUserInfo();
                }
            },
            error: function(err) {}
        });
    }

    api.addEventListener({
        name: 'me-info-getData'
    }, function(ret, err) {
        getData()
    });

    api.addEventListener({
        name: 'me-info-update'
    }, function(ret, err) {
        updateUserInfo();
    });

    api.addEventListener({
        name: 'global-login-success'
    }, function(ret, err) {
        updateUserInfo();
    });

    api.addEventListener({
        name: 'global-logout-success'
    }, function(ret, err) {
        clearUserInfo();
    });

    module.exports = {};

});
