define(function(require, exports, module) {

    var Http = require('U/http');
    var iosMagicStatus = _g.getLS('iosMagicStatus');

    var info = new Vue({
        el: '#info',
        template: _g.getTemplate('me/info-V'),
        data: {
            avatar: '',
            nickname: '',
            email: '',
            iosMagicStatus: iosMagicStatus,
        },
        created: function() {
            var UserInfo = _g.getLS('UserInfo');
            this.avatar = UserInfo.avatar;
            this.nickname = UserInfo.userName;
            this.email = UserInfo.email;
        },
        methods: {
            onItemTap: function(type) {
                switch (type) {
                    case 'avatar':
                        _g.openPicActionSheet({
                            allowEdit: true,
                            suc: function(ret) {
                                postAvatar(ret.base64Data);
                            }
                        })
                        break;
                    case 'nickname':
                        _g.openWin({
                            header: {
                                data: {
                                    title: '昵称',
                                    rightText: '保存'
                                }
                            },
                            name: 'me-edit',
                            url: '../me/edit.html',
                            pageParam: {
                                type: 'userName'
                            }
                        });
                        break;
                    case 'email':
                        _g.openWin({
                            header: {
                                data: {
                                    title: '邮箱',
                                    rightText: '保存'
                                }
                            },
                            name: 'me-edit',
                            url: '../me/edit.html',
                            pageParam: {
                                type: 'email'
                            }
                        });
                        break;
                    case 'password':
                        // as;
                        break;
                    case 'qrcode':
                        _g.openWin({
                            header: {
                                data: {
                                    title: '推广大使二维码',
                                    rightText: '保存'
                                }
                            },
                            name: 'me-qrcode',
                            url: '../me/qrcode.html',
                            bounces: false,
                            pageParam: {
                                
                            }
                        });
                        break;
                }
            }
        }
    });

    function postAvatar(data) {
        Http.ajax({
            data: {
                base64: data.split(',')[1]
            },
            isSync: true,
            url: '/api/user/avatar',
            success: function(ret) {
                if (ret.code == 200) {
                    var UserInfo = _g.getLS('UserInfo');
                    UserInfo.avatar = ret.data.avatar;
                    _g.setLS('UserInfo', UserInfo);
                    api.sendEvent({
                        name: 'me-info-update',
                    });
                }
            },
            error: function(err) {
                console.log(err)
            }
        });
    }

    function update(){
        var UserInfo = _g.getLS('UserInfo');
        info.avatar = UserInfo.avatar;
        info.nickname = UserInfo.userName;
        info.email = UserInfo.email;
    }

    api.addEventListener({
        name: 'me-info-update'
    }, function(ret, err) {
        update();
    });

    module.exports = {};

});
