define(function(require, exports, module) {

    var Http = require('U/http');
    var UserInfo = _g.getLS('UserInfo');
    var userName = UserInfo.userName;
    var placeholder = '         ';
    var trans = api && api.require('trans');

    var canvas = $('#canvas')[0];
    canvas.width = 840;
    canvas.height = 1260;
    var bgImg = $('#bgImg')[0];
    var ctx = canvas.getContext('2d');
    ctx.drawImage(bgImg, 0, 0, bgImg.width, bgImg.height, 0, 0, 840, 1260);

    ctx.textBaseline = 'top';
    ctx.textAlign = 'center';
    ctx.font = '45px 微软雅黑';
    ctx.fillStyle = 'black';
    ctx.fillText('我是 ' + getStr(userName.length), 840 *0.5, 220);
    ctx.fillStyle = '#fa9650';
    ctx.fillText(placeholder + userName, 840 *0.5, 220);
    ctx.fillStyle = 'black';
    ctx.fillText('我为中国好父母代言', 840 *0.5, 300);
    ctx.font = '36px 微软雅黑';
    ctx.fillStyle = 'black';
    ctx.fillText('扫描识别图中二维码加入我们', 840 *0.5, 1200);

    function getStr(count){
    	var str = '';
    	_.times(count * 4, function(){
    		str += ' ';
    	});
    	return str;
    }

    $('#qrcode-container').qrcode({
        "size": 335,
        "color": "#3a3",
        // "background": "#fff",
        "quiet": 1,
        "text": 'http://www.haofumu100.com/mobi/qrcode?userID=' + UserInfo.userID + '&userName=' + UserInfo.userName,
        // "image": '../../image/me/bg-qrcode.jpg'
    });

    var base64 = '';

    setTimeout(function(){
    	var qrcode = $('#qrcode-container').find('canvas')[0];
    	ctx.drawImage(qrcode, 0, 0, 335, 335, (840-335)*0.5, 610, 335, 335);
		base64 = canvas.toDataURL("image/jpeg");
    }, 0)

    function savaImage() {
    	_g.showProgress();
    	trans.saveImage({
		    base64Str: base64.split(',')[1],
		    album: true,
		}, function(ret, err){        
		    _g.hideProgress();
		    if( ret.status ){
		        _g.toast('成功保存到本地相册中!');
		    }else{
		        alert( JSON.stringify( err ) );
		    }
		});
    }

    var show = false;
    $('.ui-qrcodeDetail__title').on('click', function(){
    	show = !show;
    	if(show){
    		$('.ui-qrcodeDetail').css('transform', 'translate3d(0, 0, 0)');
    		$('.ui-qrcodeDetail').css('-webkit-transform', 'translate3d(0, 0, 0)');
    		$('.ui-qrcodeDetail').css('bottom', 0);
    		$('.ui-qrcodeDetail__title').addClass('is-active');
    	}else{
    		$('.ui-qrcodeDetail').css('transform', 'translate3d(0, 100%, 0)');
    		$('.ui-qrcodeDetail').css('-webkit-transform', 'translate3d(0, 100%, 0)');
    		$('.ui-qrcodeDetail').css('bottom', '50px');
    		$('.ui-qrcodeDetail__title').removeClass('is-active');
    	}
    });
    
    function getData() {
        Http.ajax({
            data: {
                type: 'qrcodeInfo'
            },
            url: '/api/system/info',
            success: function(ret) {
                if (ret.code == 200) {
                    var str = '';
                    _.each(ret.data, function(item, index){
                        str += '\
                            <div class="ui-qrcodeDetail__item">\
                                <h1>' +item.title+ '</h1>\
                                <p>' +item.subtitle+ '</p>\
                            </div>\
                        ';
                    });
                    $('.ui-qrcodeDetail__list').html(str);
                }
            },
            error: function(err) {}
        });
    }

    getData();

    api.addEventListener({
        name: 'me-qrcode-save'
    }, function(ret, err) {
        savaImage();
    });

    module.exports = {};

});
