define(function(require, exports, module) {
    var Http = require('U/http');
    var Bank = require('U/bank');

    var home = new Vue({
        el: '#addCard',
        template: _g.getTemplate('money/addCard-main-V'),
        data: {
            cardNO: '',
            openBank: '',
            name: '',
            IDcard: '',
            phone: '',
        },

        methods: {
            onContactTap: function() {
                api.call({
                    type: 'tel_prompt',
                    number: '18023001327'
                });
            },
            oncardNOBlur: function() {
                if (this.cardNO == '') return;
                var result = Bank.match(this.cardNO);
                if (result.code == 0) {
                    _g.toast(result.msg);
                } else if (result.code == 1) {
                    this.openBank = result.msg.split('·')[0];
                }
            },
            onPostTap: function() {
                var phoneReg = /^1[0-9]{10}$/;
                if (this.cardNO == '') {
                    _g.toast('银行卡号不能为空!')
                } else if (this.openBank == '') {
                    _g.toast('开户银行不能为空!')
                } else if (this.name == '') {
                    _g.toast('姓名不能为空!')
                } else if (this.IDcard == '') {
                    _g.toast('证件号不能为空!')
                } else if (!phoneReg.test(this.phone)) {
                    _g.toast('手机号不正确!')
                } else {
                    api.confirm({
                        title: '确定提交?',
                        msg: '确定该银行卡信息无误, 并且持卡人为通过实名验证的本人?',
                        buttons: ['确定', '取消']
                    }, function(ret, err) {
                        if (ret.buttonIndex == 1) {
                            home.postData();
                        }
                    });
                }
            },
            postData: function() {
                Http.ajax({
                    data: {
                        cardNum: this.cardNO,
                        openBank: this.openBank,
                        name: this.name,
                        certNum: this.IDcard,
                        phone: this.phone,
                    },
                    isSync: true,
                    url: '/api/wallet/addCard',
                    success: function(ret) {
                        if (ret.code == 200) {
                            api.sendEvent({
                                name: 'money-withdrawals-changeCard',
                            });
                            api.alert({
                                title: '提示',
                                msg: '更新银行卡信息成功!',
                            }, function(ret, err) {
                                api.closeWin();
                            });
                        }
                    },
                    error: function(err) {}
                });
            }
        },
    });


    module.exports = {};
});
