define(function(require, exports, module) {
    var Http = require('U/http');

    var home = new Vue({
        el: '#home',
        template: _g.getTemplate('money/home-main-V'),
        data: {
            money: 0,
        },
        created: function() {
            var UserInfo = _g.getLS('UserInfo');
            this.money = UserInfo.wallet;
        },
        methods: {
            onCashTap: function() {
                var UserInfo = _g.getLS('UserInfo');
                if (UserInfo.isCert == 1) {
                    // 已认证
                    getBankData();
                } else {
                    // 未认证
                    _g.toast('请先通过实名验证后再使用提现功能!');
                }
            },
            onCertTap: function() {
                var UserInfo = _g.getLS('UserInfo');
                if (UserInfo.isCert == 1) {
                    // 已认证
                    _g.openWin({
                        header: {
                            data: {
                                title: '实名认证',
                            }
                        },
                        name: 'money-confirmSuccess',
                        url: '../money/confirmSuccess.html',
                        pageParam: {}
                    });
                } else if (UserInfo.isCert == 2) {
                    api.confirm({
                        title: '提示',
                        msg: '实名认证不通过, 请重新提交认证资料',
                        buttons: ['确定', '取消']
                    }, function(ret, err) {
                        if (ret.buttonIndex == 1) {
                            opneRealName();
                        }
                    });
                } else if (UserInfo.isCert == 3) {
                    api.confirm({
                        title: '提示',
                        msg: '实名认证审核中, 是否重新提交认证资料',
                        buttons: ['确定', '取消']
                    }, function(ret, err) {
                        if (ret.buttonIndex == 1) {
                            opneRealName();
                        }
                    });
                } else {
                    // 未认证
                    opneRealName();
                }
            },
            onQuestionTap: function() {

            },
        },
    });

    function opneRealName() {
        _g.openWin({
            header: {
                data: {
                    title: '实名认证',
                }
            },
            name: 'money-realName',
            url: '../money/realName.html',
            pageParam: {}
        });
    }

    function getBankData() {
        Http.ajax({
            data: {},
            isSync: true,
            url: '/api/wallet/getCards',
            success: function(ret) {
                if (ret.code == 200) {
                    if (ret.data) {
                        // 已经添加银行卡
                        _g.openWin({
                            header: {
                                data: {
                                    title: '提现',
                                    rightText: '换卡',
                                }
                            },
                            name: 'money-withdrawals',
                            url: '../money/withdrawals.html',
                            pageParam: {}
                        });
                    } else {
                        // 还没添加银行卡
                        _g.openWin({
                            header: {
                                data: {
                                    title: '绑定银行卡',
                                }
                            },
                            name: 'money-addCard',
                            url: '../money/addCard.html',
                            softInputMode: 'auto',
                            pageParam: {}
                        });
                    }
                }
            },
            error: function(err) {}
        });
    }

    api.addEventListener({
        name: 'money-home-detail'
    }, function(ret, err) {
        _g.openWin({
            header: {
                data: {
                    title: '实名认证',
                }
            },
            name: 'money-realName',
            url: '../money/realName.html',
            pageParam: {}
        });
    });

    api.addEventListener({
        name: 'money-home-changeCard'
    }, function(ret, err) {
        _g.openWin({
            header: {
                data: {
                    title: '更换银行卡',
                }
            },
            name: 'money-addCard',
            url: '../money/addCard.html',
            softInputMode: 'auto',
            pageParam: {}
        });
    });

    module.exports = {};
});
