define(function(require, exports, module) {
    var Http = require('U/http');
    var resultData = [];
    var home = new Vue({
        el: '#withdrawals',
        template: _g.getTemplate('money/withdrawals-main-V'),
        data: {
            wallet: 0,
            money: '',
            isMoneyInput: 'false',
            cardID: '',
            cardNum: '',
            openBank: '',
            phone: '',
            certNum: '',
            name: ''
        },
        created: function() {
            var UserInfo = _g.getLS('UserInfo');
            this.wallet = UserInfo.wallet;
        },
        methods: {
            onMoneyInput: function() {
                if (this.money == '') this.isMoneyInput = false;
                else this.isMoneyInput = true;
                if ('' + Number(this.money) == 'NaN' && this.money != '') {
                    api.alert({
                        title: '提示',
                        msg: '请输入整数金额!',
                    });
                    this.money = '';
                } else if (Number(this.money + '00') > this.wallet) {
                    this.money = (this.wallet + '').slice(0, -2);
                }
            },
            clearMoney: function() {
                this.money = '';
                this.isMoneyInput = false;
            },
            onPostTap: function() {
                if (this.money == '') {
                    _g.toast('请输入提现金额!')
                } else if (Number(this.money + '00') < 10000) {
                    _g.toast('提现金额至少100元!')
                } else {
                    var self = this;
                    api.confirm({
                        title: '提示',
                        msg: '确定申请提现?',
                        buttons: ['确定', '取消']
                    }, function(ret, err) {
                        if (ret.buttonIndex) {
                            self.postCash();
                        }
                    });
                }
            },
            postCash: function() {
                Http.ajax({
                    data: {
                        value: Number(this.money + '00'),
                        extra: {
                            cardID: home.cardID,
                            cardNum: home.cardNum,
                            openBank: home.openBank,
                            phone: home.phone,
                            certNum: home.certNum,
                            name: home.name,
                        },
                    },
                    isSync: true,
                    url: '/api/wallet/cash',
                    success: function(ret) {
                        if (ret.code == 200) {
                            api.sendEvent({
                                name: 'me-info-getData'
                            });
                            _g.closeWins(['money-home-win']);
                            api.alert({
                                title: '提示',
                                msg: '提现申请成功!',
                            }, function(ret, err) {
                                api.closeWin();
                            });
                        }
                    },
                    error: function(err) {}
                });
            }
        },
    });

    function getData() {
        Http.ajax({
            data: {},
            isSync: true,
            url: '/api/wallet/getCards',
            success: function(ret) {
                if (ret.code == 200) {
                    home.cardID = ret.data.id;
                    home.cardNum = ret.data.cardNum;
                    home.openBank = ret.data.openBank;
                    home.phone = ret.data.phone;
                    home.certNum = ret.data.certNum;
                    home.name = ret.data.name;
                }
            },
            error: function(err) {}
        });
    }

    getData();

    api.addEventListener({
        name: 'money-withdrawals-changeCard'
    }, function(ret, err) {
        getData();
    });

    module.exports = {};
});
