define(function(require, exports, module) {

    var Http = require('U/http');

    var main = new Vue({
        el: '#main',
        template: _g.getTemplate('question/index-main-V'),
        data: {
            title: '',
            detail: '',
            list: [{
                title: '我家的孩子不听话',
                detail: '我家的孩子不听话我家的孩子听话',
                date: '2016-04-08',
            }, {
                title: '我家的孩子不听话',
                detail: '我家的孩子不听话我家的孩子不听话我家的孩子不听话我家的孩子不听话我家的孩子',
                date: '2016-04-08',
            }]
        },
        created: function() {
            this.list = [];
        },
        methods: {
            focus: function(item) {
                if (document.activeElement === item) {
                    return
                }
                item.focus();
            },
            confirm: function() {
                if(this.title == ''){
                    _g.toast('问题不能为空');
                    return;
                }
                if(this.detail == ''){
                    _g.toast('描述不能为空');
                    return;
                }
                postQuestion();
            }
        }
    });

    function postQuestion() {
        Http.ajax({
            data: {
                title: main.title,
                content: main.detail,
            },
            isSync: true,
            url: '/api/question/create',
            success: function(ret) {
                if (ret.code == 200) {
                    main.title = '';
                    main.detail = '';
                    getData();
                }
            },
            error: function(err) {}
        });
    }

    function getData() {
        Http.ajax({
            data: {},
            url: '/api/question/list',
            success: function(ret) {
                if (ret.code == 200) {
                    setTimeout(function() {
                        main.list = _.map(ret.data, function(item) {
                            return {
                                id: item.id,
                                title: item.title,
                                detail: item.content,
                                date: item.updDate,
                            }
                        });
                    }, 0);
                }
            },
            error: function(err) {}
        });
    }

    getData();

    module.exports = {};

});
