define(function(require, exports, module) {

    var iosMagicStatus = _g.getLS('iosMagicStatus')
    var Http = require('U/http');
    var Tips = require('U/tips');
    var Video = require('U/video');
    var index = api.pageParam.index;
    var id = api.pageParam.id;
    var tag = api.pageParam.tag;
    var detailData = {};
    var downloadList = _g.getLS('download') || [];
    var downloadObj = {};
    var time = '';
    // var photo = '';
    var initFrameRect = {
        x: 0,
        y: api.winHeight - api.frameHeight,
        w: 'auto',
        h: api.frameHeight
    };

    switch (Number(tag)) {
        case 1:
            var videoShow = true;
            var videoPlayer = api.require('videoPlayer');
            break;
        case 2:
        case 4:
            var imageShow = false;
            break;
        case 3:
            var audioShow = true;
            var netAudio = api.require('audio');
            break;
    }

    var result = {};

    var processWidth = 0;
    var processBtnSize = 0;
    var nowX = 0;
    var moveX = 0;
    var startX = 0;

    var image = new Vue({
        el: '#image',
        template: _g.getTemplate('read/detail-image-V'),
        data: {
            photo: '',
            image: '',
            title: '',
            imageShow: false,
            videoShow: false,
            audioShow: false,
            playing: false,
            duration: 0,
            current: 0,
            fullscreen: false,
        },
        created: function() {
            this.image = '';
            this.title = '';
            this.imageShow = !!imageShow;
            this.videoShow = !!videoShow;
            this.audioShow = !!audioShow;
        },
        ready: function() {
            processWidth = $('.ui-video__slide').width();
            processBtnSize = $('.ui-video__block').width();
            var $processBtn = $('.ui-video__block');
            $processBtn.on('touchstart', function(e) {
                image.playing = false;
                if (audioShow) {
                    netAudio.pause();
                }
                if (videoShow) {
                    videoPlayer.pause();
                }
                var touch = e.touches[0];
                startX = touch.pageX;
                moveX = 0;
            }).on('touchmove', function(e) {
                var touch = e.touches[0];
                moveX = touch.pageX - startX;
                var position = nowX + moveX;
                position = position < 0 ? 0 : position;
                position = position > (processWidth - 6) ? (processWidth - 6) : position;
                position = position / processWidth * 100;
                $processBtn.css('left', position + '%');
            }).on('touchend', function(e) {
                image.playing = true;
                var position = nowX + moveX;
                nowX = position;
                position = position < 0 ? 0 : position;
                position = position > (processWidth - 6) ? (processWidth - 6) : position;
                position = position / processWidth;
                $processBtn.css('left', (position * 100) + '%');
                if (audioShow) {
                    netAudio.setProgress({
                        progress: position * 100
                    });
                    openAudio();
                }
                if (videoShow) {
                    videoPlayer.seekTo({
                        seconds: image.duration * position
                    });
                    videoPlayer.start();
                }
            });
        },
        filters: {
            transTime: function(value) {
                value = Math.round(value);
                var min = Math.floor(value / 60);
                var s = value % 60;
                min = min > 9 ? min : ('0' + min);
                s = s > 9 ? s : ('0' + s);
                return min + ':' + s;
            }
        },
        methods: {
            onFullBtnTap: function() {
                Video.openFullScreen(result);
                return;
                if (this.videoShow) {
                    Video.openFullScreen(videoPlayer);
                    return;
                    if (api.systemType == 'android') {
                        api.setFrameAttr({
                            name: api.frameName,
                            rect: {
                                x: 0,
                                y: 0,
                                w: 'auto',
                                h: 'auto'
                            },
                        });
                    }
                    videoPlayer.setRect({
                        fullscreen: true
                    });
                    videoPlayer.fullScreen();
                    this.fullscreen = true;
                }
            },
            onPlayBtnTap: function() {
                this.playing = !this.playing;
                if (this.videoShow) {
                    if (this.playing) videoPlayer.start();
                    else videoPlayer.pause();
                }
                if (this.audioShow) {
                    if (this.playing) openAudio();
                    else netAudio.pause();
                }
            },
            onImageTap: function() {
                // api.openWin({
                //     name: 'book-index-win',
                //     url: '../book/index.html',
                //     pageParam: {
                //         name: 'test'
                //     }
                // });
            }
        }
    });
    var content = new Vue({
        el: '#content',
        template: _g.getTemplate('read/detail-content-V'),
        data: {
            videoShow: false,
            audioShow: false,
            content: [
                '天下父母谁不希望自己的孩子能够听话懂事，但事实上，他们总会搅得我们这些大人一个头两个大。小时候顽皮还好说，最多吼一嗓子会立马变乖，但是自从孩子上了初中，就像变了一个人，想法多不说还开始爱顶嘴了，其实，这就是青春叛逆期到来的表现。家长打骂不行，又放任不得，说教更是听不进去，到底孩子叛逆怎么办？',
                '(本段为《<b>孩子叛逆该怎么办</b>》音频第二段，想了解更多内容，请点击本页面右上角封面图进行获取）。',
                '天下父母谁不希望自己的孩子能够听话懂事，但事实上，他们总会搅得我们这些大人一个头两个大。小时候顽皮还好说，最多吼一嗓子会立马变乖，但是自从孩子上了初中，就像变了一个人，想法多不说还开始爱顶嘴了，其实，这就是青春叛逆期到来的表现。家长打骂不行，又放任不得，说教更是听不进去，到底孩子叛逆怎么办？',
                '天下父母谁不希望自己的孩子能够听话懂事，但事实上，他们总会搅得我们这些大人一个头两个大。小时候顽皮还好说，最多吼一嗓子会立马变乖，但是自从孩子上了初中，就像变了一个人，想法多不说还开始爱顶嘴了，其实，这就是青春叛逆期到来的表现。家长打骂不行，又放任不得，说教更是听不进去，到底孩子叛逆怎么办？',
            ]
        },
        ready: function() {
            if (imageShow === false) {
                $('.ui-content').css('margin-top', '0px');
            }
        },
        created: function() {
            this.content = [];
            this.videoShow = videoShow;
            this.audioShow = audioShow;

        }
    });
    var footer = new Vue({
        el: '#footer',
        template: _g.getTemplate('read/detail-footer-V'),
        data: {
            isLike: false,
            isFavorite: false,
            download: 0,
        },
        methods: {
            back: function() {
                api.closeWin();
            },
            favorite: function() {
                if (_g.checkUser()) {
                    postFavorite(id, this.isFavorite ? 'del' : 'add');
                }
            },
            comment: function() {
                pause();
                if (_g.checkUser()) {
                    _g.openWin({
                        header: {
                            template: 'comment/index-header-V',
                            data: {
                                extra: result.content.extra,
                                title: result.content.title,
                                subtitle: result.content.desc,
                            }
                        },
                        name: 'comment-index',
                        url: '../comment/index.html',
                        softInputMode: 'auto',
                        pageParam: {
                            topicId: id,
                            index: index,
                        }
                    });
                }
            },
            like: function() {
                if (_g.checkUser()) {
                    postLike(id, this.isLike ? 'greatCancel' : 'great');
                }
            },
            share: function() {
                var opts = {}
                opts['id'] = id;
                opts['tag'] = tag;
                opts['title'] = result.content.title;
                opts['description'] = result.content.desc
                _g.openShare(opts);
            },
            doDownload: function() {
                _g.showProgress();
                var path = '';
                var isDown = 0;
                if (tag == 1) {
                    path += result.content.video;
                } else if (tag == 3) {
                    path += result.content.audio;
                }
                _.each(downloadList, function(n, i) {
                    if (n.path == path) {
                        isDown = 1;
                    }
                });
                if (isDown) {
                    if (tag == 1) {
                        Tips.show({
                            title: '下载过的视频'
                        });
                    } else if (tag == 3) {
                        Tips.show({
                            title: '下载过的音频'
                        });
                    }
                    _g.hideProgress();
                } else {
                    Tips.show({
                        title: '添加至下载列表'
                    });
                    api.download({
                        url: CONFIG.HOST + result.content.photo,
                        savePath: 'fs:/' + result.content.photo,
                        report: true,
                        cache: true,
                        allowResume: true
                    }, function(ret, err) {
                        if (ret.state == 1) {
                            //下载成功
                            downloadObj = {
                                photo: result.content.photo,
                                id: result.content.id,
                                tag: tag,
                                cover: result.content.cover,
                                path: path,
                                state: -1,
                                title: result.content.title,
                                size: 0,
                                data: result
                            }
                            downloadList.push(downloadObj);
                            _g.setLS('download', downloadList);
                            _g.hideProgress();
                            api && api.sendEvent({
                                name: 'do-download',
                                extra: {
                                    host: CONFIG.HOST,
                                    url: path,
                                    savePath: path,
                                }
                            })
                        }
                    });

                }
            }
        }
    });

    function pause() {
        image.playing = false;
        if (videoShow) videoPlayer.pause();
        if (audioShow) netAudio.pause();
    }

    function postLike(topicId, type) {
        Http.ajax({
            data: {
                topicId: topicId
            },
            url: '/api/topic/' + type,
            success: function(ret) {
                if (ret.code == 200) {
                    footer.isLike = !footer.isLike;
                    api.sendEvent({
                        name: 'read-list-update-one',
                        extra: {
                            index: index
                        }
                    });
                    if (type == 'great') {
                        Tips.show({
                            title: '点赞成功',
                            subtitle: '+2积分'
                        });
                    } else if (type == 'greatCancel') {
                        Tips.show({
                            title: '取消点赞',
                            subtitle: '-2积分'
                        });
                    }
                }
            },
            error: function(err) {}
        });
    }

    function postFavorite(topicId, type) {
        Http.ajax({
            data: {
                topicId: topicId
            },
            url: '/api/favorite/' + type,
            success: function(ret) {
                if (ret.code == 200) {
                    footer.isFavorite = !footer.isFavorite;
                    if (type == 'add') {
                        Tips.show({
                            title: '已加入收藏',
                        });
                    } else if (type == 'del') {
                        Tips.show({
                            title: '已取消收藏',
                        });
                    }
                }
            },
            error: function(err) {}
        });
    }

    var firstOpenAudio = true;
    var firstOpenVideo = true;
    // if (audioShow) {
    //     netAudio.setVolume({
    //         volume: 0
    //     });
    // }

    function openAudio() {
        var path = '';
        var ishas = 0;
        _.each(_g.getLS('download'), function(n, i) {
            if (n.path == result.content.audio) {
                ishas = 1;
                path = 'fs:/' + n.path;
            }
        });
        if (!ishas) {
            path = CONFIG.HOST + result.content.audio;
        }

        netAudio.play({
            path: path
        }, function(ret, err) {
            if (ret) {
                image.playing = true;
                image.duration = ret.duration;
                image.current = ret.current;
                if (ret.complete) {
                    image.playing = false;
                }
                // if (firstOpenAudio) {
                //     setTimeout(function() {
                //         pause();
                //         firstOpenAudio = false;
                //         netAudio.setVolume({
                //             volume: 0.6
                //         });
                //     }, 0);
                // }
            } else {
                alert(JSON.stringify(err));
            }
        });
    }

    function openVideo() {
        var path = '';
        var ishas = 0;
        _.each(_g.getLS('download'), function(n, i) {
            if (n.path == result.content.video) {
                path = 'fs:/' + n.path;
                ishas = 1;
            }
        })
        if (!ishas) {
            path = CONFIG.HOST + result.content.video
        }

        if (api.systemType == 'android') {
            var opts = {
                rect: {
                    x: 15,
                    y: 15,
                    w: api.frameWidth - 15 * 2,
                    h: 150
                },
                fixedOn: api.frameName,
                autoPlay: false,
                path: path
                    // path: CONFIG.HOST + result.content.video
            };
        } else {
            var opts = {
                rect: {
                    x: 15,
                    y: api.winHeight - api.frameHeight + 15,
                    w: api.frameWidth - 15 * 2,
                    h: 150
                },
                autoPlay: false,
                path: path
                    // path: CONFIG.HOST + result.content.video
            };
        }
        videoPlayer.open(opts, function(ret, err) {
            if (ret.status) {
                if (api.systemType == 'android') {
                    image.duration = ret.duration;
                    image.playing = false;
                }

                videoPlayer.removeEventListener({
                    name: 'play'
                });
                videoPlayer.removeEventListener({
                    name: 'doubleClick'
                });
                videoPlayer.removeEventListener({
                    name: 'click'
                });


                videoPlayer.addEventListener({
                    name: 'play'
                }, function(ret, err) {
                    if (ret.eventType == 'start') {
                        image.playing = true;
                        if (firstOpenVideo) {
                            firstOpenVideo = false;
                            image.playing = false;
                        }
                    }
                    if (ret.eventType == 'playing') {
                        image.playing = true;
                        image.current = ret.current;
                    }
                    if (ret.eventType == 'pause') {
                        image.playing = false;
                    }
                    if (ret.eventType == 'stop') {
                        image.playing = false;
                    }
                    if (ret.eventType == 'complete') {
                        image.playing = false;
                    }
                });
                videoPlayer.addEventListener({
                    name: 'doubleClick'
                }, function(ret, err) {
                    cancelFullScreen();
                });

                videoPlayer.addEventListener({
                    name: 'click'
                }, function(ret, err) {
                    image.onPlayBtnTap();
                });

                if (ret.eventType == 'show') {
                    image.duration = ret.duration;
                }
                if (ret.eventType == 'playing') {
                    image.playing = true;
                }
            } else {
                alert(JSON.stringify(err));
            }
        });
    }

    function cancelFullScreen() {
        if (api.systemType == 'android') {
            api.setFrameAttr({
                name: api.frameName,
                rect: initFrameRect,
            });
        }
        videoPlayer.setRect({
            fullscreen: false
        });
        videoPlayer.cancelFullScreen();
        image.fullscreen = false;
    }

    function getData() {
        Http.ajax({
            data: {
                id: id
            },
            isSync: true,
            url: '/api/topic/detail',
            success: function(ret) {
                if (ret.code == 200) {
                    detailData = ret.data;
                    if (tag == 3) {
                        // 只有音频可以下载
                        footer.download = 1;
                        // 没通过审核, 隐藏部分入口
                        if (!iosMagicStatus) {
                            footer.download = 0;
                        }
                    } else {
                        footer.download = 0;
                    }
                    result = ret.data;
                    image.title = ret.data.content.title;
                    image.image = ret.data.content.photo;
                    footer.isLike = ret.data.status.great;
                    footer.isFavorite = ret.data.status.favorite;
                    content.content = [ret.data.content.article];
                    if (videoShow) {
                        content.content = [ret.data.content.videoArticle];
                        openVideo();
                    }
                    if (audioShow) {
                        content.content = [ret.data.content.audioArticle];
                        // openAudio();
                    }
                }
            },
            error: function(err) {
                if (api.connectionType == 'unknown' || api.connectionType == 'none') {
                    _.each(_g.getLS('download'), function(n, i) {
                        if (n.id == id) {
                            footer.download = 0;
                            result = n.data;
                            image.title = n.data.content.title;
                            image.image = api.fsDir + n.photo;
                            footer.isLike = 0;
                            footer.isFavorite = 0;
                            content.content = [n.data.content.article];
                            setTimeout(function() {
                                $('#content').find('img').css('display', 'none');
                                $('.ui-video__bg').css({ 'background-image': 'url(' + image.image + ')' });
                            }, 0);
                            if (videoShow) {
                                content.content = [n.data.content.videoArticle];
                                openVideo();
                            }
                            if (audioShow) {
                                content.content = [n.data.content.audioArticle];
                                // openAudio();
                            }
                        }
                    });
                }
            }
        });
    }

    getData();

    api.addEventListener({
        name: 'detail-win-keyback'
    }, function(ret, err) {
        if (image.fullscreen) {
            cancelFullScreen();
            return;
        }
        api && api.closeWin();
    });

    api.addEventListener({
        name: 'detail-win-newPage'
    }, function(ret, err) {
        pause();
    });

    api && api.addEventListener({
        name: 'read-detail-download'
    }, function(ret, err) {
        api && api.sendEvent({
            name: 'refresh-downloadlist',
            extra: {
                index: 0
            }
        });
        Tips.show({
            title: '下载完成'
        });
        // if (ret.value.state == 1) {
        //     downloadList[time].size = ret.value.fileSize;
        //     downloadList[time].state = ret.value.state;
        //     _g.setLS('download', downloadList);
        // } else {
        //     downloadList[time].size = ret.value.fileSize;
        //     downloadList[time].state = ret.value.state;
        // }
    });
    api && api.addEventListener({
        name: 'download-error'
    }, function(ret, err) {
        Tips.show({
            title: '下载失败'
        });
    });

    api && api.addEventListener({
        name: 'download-image'
    }, function(ret, err) {
        image.photo += ret.value.photo;
    });

    module.exports = {};

});
