define(function(require, exports, module) {

    var Http = require('U/http');

    var readList = new Vue({
        el: '#readList',
        template: _g.getTemplate('read/index-list-V'),
        data: {
            list: [{
                id: 0,
                photo: 'http://usr.im/400x400',
                title: '测试',
                content: '',
                type: 1,
                time: '2小时前',
                comment: 0,
                nice: 0,
            }]
        },
        created: function() {
            this.list = [];
            window.nowPage = 1;
            getData(window.nowPage);
        },
        methods: {
            onItemTap: function(index) {
                _g.openWin({
                    header: {
                        template: 'read/detail-header-V',
                        data: {
                            extra: this.list[index].extra,
                            title: this.list[index].title,
                            subtitle: this.list[index].content,
                            // id: this.list[index].id,
                            // cover: this.list[index].cover,
                        }
                    },
                    name: 'read-detail',
                    url: '../read/detail.html',
                    bounces: false,
                    pageParam: {
                        index: index,
                        id: this.list[index].id,
                        tag: this.list[index].tag,
                    }
                });
            },
            onCommentTap: function() {
                _g.openWin({
                    header: {
                        data: {
                            // title: '评论',
                            extra: this.list[index].extra,
                            title: this.list[index].title,
                            subtitle: this.list[index].content,
                        }
                    },
                    name: 'comment-index',
                    url: '../comment/index.html',
                    pageParam: {

                    }
                });
            },
            onNiceTap: function() {
                _g.toast('点赞了')
            }
        },
        filters: {
            transClass: function(value) {
                switch (Number(value)) {
                    case 1:
                        return 'is-video';
                        break;
                    case 2:
                        return 'is-book';
                        break;
                    case 3:
                        return 'is-listen';
                        break;
                    case 4:
                        return 'is-book';
                        break;
                }
            },
            transText: function(value) {
                switch (Number(value)) {
                    case 1:
                        return '解读';
                        break;
                    case 2:
                        return '杂谈';
                        break;
                    case 3:
                        return '轻听';
                        break;
                    case 4:
                        return '活动';
                        break;
                }
            },
        }
    });

    function getData(page) {
        Http.ajax({
            data: {
                type: 1,
                page: page
            },
            isSync: true,
            url: '/api/topic/list',
            success: function(ret) {
                if (ret.code == 200) {
                    setTimeout(function() {
                        
                        var list = [];

                        if (ret.data.length == 0) {
                            _g.toast('没有更多了~');
                            window.isNoMore = true;
                        }

                        list = _.map(ret.data, function(item) {
                            return {
                                id: item.id,
                                photo: item.photo,
                                cover: item.cover,
                                title: item.title,
                                content: item.desc,
                                type: item.type,
                                tag: item.tag,
                                time: item.updDate,
                                comment: item.commentNum,
                                nice: item.greatNum,
                                extra: item.extra,
                            }
                        });

                        if (window.nowPage == 1) {
                            readList.list = list;
                        } else {
                            readList.list = readList.list.concat(list);
                        }

                    }, 0);
                }
            },
            error: function(err) {}
        });
    }

    function getOne(index) {
        Http.ajax({
            data: {
                id: readList.list[index].id
            },
            url: '/api/topic/detail',
            success: function(ret) {
                if (ret.code == 200) {
                    var item = ret.data.content;
                    var one = readList.list[index];
                    one.time = item.updDate;
                    one.comment = item.commentNum;
                    one.nice = item.greatNum;
                }
            },
            error: function(err) {}
        });
    }

    _g.setPullDownRefresh(function() {
        window.nowPage = 1;
        getData(window.nowPage);
    });

    _g.setLoadmore(function() {
        window.nowPage++;
        getData(window.nowPage);
    });

    api.addEventListener({
        name: 'read-list-update-one'
    }, function(ret, err) {
        var index = ret.value.index;
        if(index){
            getOne(index);
        }
        else{
            window.nowPage = 1;
            getData(window.nowPage);
        }
    });

    module.exports = {};

});
