define(function(require, exports, module) {
    var searchText = '';
    var Http = require('U/http');
    var resultData = [];
    var type = new Vue({
        el: '#type',
        template: _g.getTemplate('search/index-type-V'),
        data: {
            list: [
                '行为',
                '情绪',
                '能力',
                '沟通',
                '习惯',
                '人际关系',
                '心里需求',
                '其他',
            ]
        },
        created: function() {
            this.list = [];
        },
        methods: {
            onDataTap: function(text) {
                result.list = [];
                setTimeout(function() {
                    api && api.sendEvent({
                        name: 'refresh-search-index',
                        extra: {
                            searchText: text
                        }
                    });
                }, 0);
            }
        }
    });
    var result = new Vue({
        el: '#result',
        template: _g.getTemplate('search/index-result-V'),
        data: {
            list: [{
                id: 0,
                tag: 0,
                title: '您是孩子的情绪教练',
                desc: '天下父母谁不希望自己的孩子能够天下父母谁不希望自己的孩子能够天下父母谁不希望自己的孩子能够',
                extra: null
            }, {
                id: 0,
                tag: 0,
                title: '您是孩子的情绪教练',
                desc: '天下父母谁不希望自己的孩子能够天下父母谁不希望自己的孩子能够天下父母谁不希望自己的孩子能够',
                extra: null
            }, {
                id: 0,
                tag: 0,
                title: '您是孩子的情绪教练',
                desc: '天下父母谁不希望自己的孩子能够天下父母谁不希望自己的孩子能够天下父母谁不希望自己的孩子能够',
                extra: null
            }, ]
        },
        created: function() {
            this.list = [];
        },
        methods: {
            onTurnDetail: function(index, item) {
                // alert(_g.j2s(resultData[index]));
                // return;
                api.openWin({
                    name: 'book-index-win',
                    url: '../book/index.html',
                    slidBackEnabled: false,
                    pageParam: {
                        extra: resultData[index],
                    }
                });
                // _g.openWin({
                //     header:{
                //         data:{
                //             title:'详情'
                //         }
                //     },
                //     name:'read-detail',
                //     url:'../read/detail.html',
                //     bounces:false,
                //     slidBackEnabled:false,
                //     pageParam:{
                //         id:item.id,
                //         tag:item.tag
                //     }
                // });
            },
            read: function(index) {
                console.log('read' + index);
            },
            listen: function(index) {
                console.log('listen' + index);
            },
            video: function(index) {
                console.log('video' + index);
            }
        }
    });
    var history = new Vue({
        el: '#history',
        template: _g.getTemplate('search/index-history-V'),
        data: {
            show: 0,
            list: []
        },
        created: function() {
            var lsHistory = _g.getLS('searchHistory');
            if (lsHistory) {
                if (lsHistory.length > 0) {
                    var newHistory = new Array();
                    for (var i = lsHistory.length - 1; i >= 0; i--) {
                        newHistory.push(lsHistory[i]);
                    };
                    this.list = newHistory;
                    this.show = 1;
                }
            }
            if (this.list) {
                this.show = 1;
            }
        },
        methods: {
            clear: function() {
                this.$data.list = [];
                _g.rmLS('searchHistory');
                _g.rmLS('searchEntity');
                this.show = 0;
            },
            onItemTap: function(text) {
                result.list = [];
                setTimeout(function() {
                    api && api.sendEvent({
                        name: 'refresh-search-index',
                        extra: {
                            searchText: text
                        }
                    });
                }, 0);
            },
            remove: function(index, item) {
                this.list.splice(index, 1);
                // var searchEntity = _g.getLS('searchEntity');
                // if (searchEntity[item]) {
                //     searchEntity[item] = 0;
                //     _g.setLS('searchEntity',searchEntity);
                // }
                _g.setLS('searchHistory', this.list);
                if (this.list.length == 0) {
                    this.show = 0;
                }
            }
        }
    });
    var tips = new Vue({
        el: '#tips',
        template: _g.getTemplate('search/index-tips-V'),
        data: {
            visibility: false
        }
    });
    var getData = function(searchText) {
        var lsHistory = _g.getLS('searchHistory');
        if (lsHistory) {
            if (lsHistory.length > 0) {
                var newHistory = new Array();
                for (var i = lsHistory.length - 1; i >= 0; i--) {
                    newHistory.push(lsHistory[i]);
                };
                history.list = newHistory;
                history.show = 1;
            }
        }
        Http.ajax({
            data: {
                title: searchText
            },
            url: '/api/topic/search',
            success: function(ret) {
                if (ret.code == 200) {
                    resultData = ret.data;
                    setTimeout(function() {
                        if (ret.data != null && ret.data.length > 0) {
                            result.list = getSearchList(ret.data);
                            history.show = 0;
                        } else {
                            result.list = [];
                            history.show = 1;
                        }
                    }, 0);
                }
            },
            error: function(err) {}
        });
    }
    var getSearchList = function(result) {
        var list = result ? result : [];
        return _.map(list, function(item) {
            return {
                id: item.id,
                tag: item.tag,
                title: item.title,
                desc: item.articleText,
                extra: null
            }
        });
    }

    function getKeywordList() {
        Http.ajax({
            data: {
                type: 'keywordInfo'
            },
            url: '/api/system/info',
            success: function(ret) {
                if (ret.code == 200) {
                    setTimeout(function() {
                        type.list = ret.data;
                    }, 0);
                }
            },
            error: function(err) {}
        });
    }

    getKeywordList();

    api && api.addEventListener({
        name: 'refresh-search-index'
    }, function(ret, err) {
        var searchText;
        var searchEntity = _g.getLS('searchEntity') || {};
        var searchHistory = _g.getLS('searchHistory') || [];
        if (ret.value.searchText) {
            searchText = ret.value.searchText;
        }
        if (searchHistory.length == 20) {
            searchHistory.splice(0, 1);
        }
        if (_g.getLS('searchHistory')) {
            if (!searchEntity[searchText]) {
                searchEntity[searchText] = 1;
                _g.setLS('searchEntity', searchEntity);
                searchHistory.push(searchText);
                _g.setLS('searchHistory', searchHistory);
            } else {
                var searchHistory = _g.getLS('searchHistory');
                _.each(searchHistory, function(n, i) {
                    if (n == searchText) {
                        searchHistory.splice(i, 1);
                    }
                });
                searchHistory.push(searchText);
                _g.setLS('searchHistory', searchHistory);
            }
        } else {
            searchEntity[searchText] = 1;
            _g.setLS('searchEntity', searchEntity);
            searchHistory.push(searchText);
            _g.setLS('searchHistory', searchHistory);
        }
        getData(ret.value.searchText);
    });

    module.exports = {};

});
