define(function(require, exports, module) {

    var Http = require('U/http');
    var AboutUs = _g.getLS('AboutUs');

    var main = new Vue({
        el: '#main',
        template: _g.getTemplate('setting/about-main-V'),
        data: {
            text: '中国好父母是基于移动互联网的学习社区，是倡导“育儿问题解答”的先行者。我们的使用是帮助广大父母解决育儿教育的问题，利用APP，带领大家一起摆脱育儿的困扰，与此同时还举办各种线下课堂活动，与教授一起面对面交流。我们愿通过知识的解答去改变自己，造福社会。',
            version: '中国好父母 1.0',
            copyright: 'Copyright@2015-2016 Soybean.All Rights Reserved.',
        },
        created: function() {
            if (AboutUs) {
                this.text = AboutUs.text;
                this.version = AboutUs.version;
                this.copyright = AboutUs.copyright;
            } else {
                this.text = '';
                this.version = '';
                this.copyright = '';
            }
        },
        methods: {

        }
    });

    var getData = function() {
        Http.ajax({
            data: {
                type: 'aboutInfo'
            },
            url: '/api/system/info',
            success: function(ret) {
                if (ret.code == 200) {
                    var AboutUs = ret.data;
                    _g.setLS('AboutUs', AboutUs);
                    setTimeout(function() {
                        main.text = ret.data.text;
                        main.version = ret.data.version;
                        main.copyright = ret.data.copyright;
                    }, 0);
                }
            },
            error: function(err) {}
        });
    }
    getData();

    module.exports = {};

});
