define(function(require, exports, module) {

    var Http = require('U/http');
    var iosMagicStatus = _g.getLS('iosMagicStatus');

    var setting = new Vue({
        el: '#setting',
        template: _g.getTemplate('setting/index-list-V'),
        data: {
            iosMagicStatus: iosMagicStatus,
            sign: false,
            name: ''
        },
        created: function() {
            var UserInfo = _g.getLS('UserInfo');
            if (UserInfo) {
                this.sign = true;
                this.name = UserInfo.userName;
            } else {
                this.sign = false;
                this.name = '';
            }

        },
        methods: {
            onItemTap: function(type) {
                switch (type) {
                    case 'user':
                        this.openUser();
                        break;
                    case 'password':
                        this.openPassword();
                        break;
                    case 'clear':
                        this.openClear();
                        break;
                    case 'order':
                        this.openOrder();
                        break;
                    case 'update':
                        this.openUpdate();
                        break;
                    case 'about':
                        this.openAbout();
                        break;
                    case 'protocol':
                        this.openProtocol();
                        break;
                }
            },
            onBtnTap: function() {
                api.confirm({
                    title: '提示',
                    msg: '退出登录',
                    buttons: ['确定', '取消']
                }, function(ret, err) {
                    if (ret.buttonIndex == 1) {
                        postLogout();
                    }
                });
            },
            openUser: function() {
                if (_g.checkUser()) {
                    _g.openWin({
                        header: {
                            data: {
                                title: '个人信息',
                            }
                        },
                        name: 'me-info',
                        url: '../me/info.html',
                        pageParam: {

                        }
                    });
                }
            },
            openPassword: function() {
                if (_g.checkUser()) {
                    _g.openWin({
                        header: {
                            data: {
                                title: '修改密码',
                            }
                        },
                        name: 'account-forget',
                        url: '../account/forget.html',
                        pageParam: {

                        }
                    });
                }
            },
            openClear: function() {
                _g.showProgress();
                api.clearCache({
                    // timeThreshold:30
                }, function() {
                    _g.hideProgress();
                    _g.toast('缓存清理成功');
                });
            },
            openOrder: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '订单列表',
                        }
                    },
                    name: 'order-index',
                    url: '../order/index.html',
                    pageParam: {

                    }
                });
            },
            openUpdate: function() {
                _g.toast('检查版本');
            },
            openAbout: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '关于中国好父母',
                        }
                    },
                    name: 'setting-about',
                    url: '../setting/about.html',
                    pageParam: {

                    }
                });
            },
            openProtocol: function() {
                _g.openWin({
                    header: {
                        data: {
                            title: '会员服务协议',
                        }
                    },
                    name: 'setting-protocol',
                    url: '../setting/protocol.html',
                });
            },
        }
    });

    function postLogout() {
        Http.ajax({
            data: {},
            url: '/api/user/logout',
            success: function(ret) {
                if (ret.code == 200) {
                    _g.rmLS('UserInfo');
                    _g.rmLS('sessionID');
                    api.sendEvent({
                        name: 'global-logout-success'
                    });
                    api && api.closeWin();
                }
            },
            error: function(err) {}
        });
    }

    function update() {
        var UserInfo = _g.getLS('UserInfo');
        setting.name = UserInfo.userName;
    }

    api.addEventListener({
        name: 'me-info-update'
    }, function(ret, err) {
        update();
    });

    module.exports = {};

});
