define(function(require, exports, module) {

    var weibo = api.require('weibo');
    var qq = api.require('qq');
    var wx = api.require('wx');
    var Http = require('U/http');
    var id = api && api.pageParam.id;
    var tag = api && api.pageParam.tag;
    var title = api && api.pageParam.title;
    var description = api && api.pageParam.description;
    var UserInfo = _g.getLS('UserInfo');

    var main = new Vue({
        el: '#main',
        template: _g.getTemplate('share/index-main-V'),
        data: {
            list: [{
                tag: 'is-weibo',
                title: '微博'
            }, {
                tag: 'is-qq',
                title: 'QQ'
            }, {
                tag: 'is-weixin',
                title: '微信好友'
            }, {
                tag: 'is-weixin2',
                title: '朋友圈'
            }]
        },
        methods: {
            onMaskTap: function() {
                api.setFrameAttr({
                    name: 'share-index-frame',
                    hidden: true
                });
            },
            shareSuccess: function(type) {
                Http.ajax({
                    data: {
                        type: type
                    },
                    url: '/api/user/share',
                    success: function(ret) {
                        if (ret.code == 200) {
                            api.sendEvent({
                                name: 'me-info-getData',
                            });
                        }
                    },
                    error: function(err) {}
                });
            },
            onItemTap: function(index) {
                var self = this;
                var shareHost = 'http://www.haofumu100.com';
                switch (this.list[index].tag) {
                    case 'is-weibo':
                        weibo.isInstalled(function(ret) {
                            if (ret.status) {
                                weibo.shareWebPage({
                                    text: description,
                                    title: title,
                                    description: description,
                                    thumb: 'widget://image/common/icon-share-logo.png',
                                    contentUrl: shareHost + '/html/read/detail.html?from=sina&id=' + id + '&tag=' + tag + '&userID=' + UserInfo.userID
                                }, function(ret, err) {
                                    if (ret.status) {
                                        self.shareSuccess(3);
                                    }
                                });
                            } else {
                                alert('未安装新浪微博客户端');
                            }
                        });
                        break;
                    case 'is-qq':
                        qq.installed(function(ret, err) {
                            if (ret.status) {
                                qq.shareNews({
                                    url: shareHost + '/html/read/detail.html?from=qq&id=' + id + '&tag=' + tag + '&userID=' + UserInfo.userID,
                                    title: title,
                                    description: description,
                                    imgUrl: 'widget://image/common/icon-share-logo.png',
                                }, function(ret, err) {
                                    if (ret.status) {
                                        self.shareSuccess(4);
                                    } else {
                                        // alert(err.code);
                                    }
                                });
                            } else {
                                api.alert({ msg: "没有安装" });
                            }
                        });
                        break;
                    case 'is-weixin':
                        wx.isInstalled(function(ret, err) {
                            if (ret.installed) {
                                wx.shareWebpage({
                                    // apiKey: 'wxe1dea687172c442a',
                                    // scene: 'session',
                                    // title: '您身边的家庭教育专家',
                                    // description: '中国好父母APP打造全球家庭系统教育领导品牌，在线学习亲子教育主题',
                                    // thumb: 'widget://image/common/icon-share-logo.png',
                                    // contentUrl: 'http://mp.weixin.qq.com/s?__biz=MzIyMzM1Njg1Ng==&mid=100000025&idx=1&sn=ad3f49e0598834e579c2761888fafd40&scene=18'
                                    apiKey: 'wxe1dea687172c442a',
                                    scene: 'session',
                                    title: title,
                                    description: description,
                                    thumb: 'widget://image/common/icon-share-logo.png',
                                    contentUrl: shareHost + '/html/read/detail.html?id=' + id + '&tag=' + tag + '&userID=' + UserInfo.userID
                                }, function(ret, err) {
                                    if (ret.status) {
                                        self.shareSuccess(2);
                                    } else {
                                        // alert(err.code);
                                    }
                                });
                            } else {
                                alert('当前设备未安装微信客户端');
                            }
                        });
                        break;
                    case 'is-weixin2':
                        wx.isInstalled(function(ret, err) {
                            if (ret.installed) {
                                wx.shareWebpage({
                                    // apiKey: 'wxe1dea687172c442a',
                                    // scene: 'timeline',
                                    // title: '您身边的家庭教育专家',
                                    // description: '中国好父母APP打造全球家庭系统教育领导品牌，在线学习亲子教育主题',
                                    // thumb: 'widget://image/common/icon-share-logo.png',
                                    // contentUrl: 'http://mp.weixin.qq.com/s?__biz=MzIyMzM1Njg1Ng==&mid=100000025&idx=1&sn=ad3f49e0598834e579c2761888fafd40&scene=18'
                                    apiKey: 'wxe1dea687172c442a',
                                    scene: 'timeline',
                                    title: title,
                                    description: description,
                                    thumb: 'widget://image/common/icon-share-logo.png',
                                    contentUrl: shareHost + '/html/read/detail.html?id=' + id + '&tag=' + tag + '&userID=' + UserInfo.userID
                                }, function(ret, err) {
                                    if (ret.status) {
                                        self.shareSuccess(1);
                                    } else {
                                        // alert(err.code);
                                    }
                                });
                            } else {
                                alert('当前设备未安装微信客户端');
                            }
                        });
                        break;
                }
                self.onMaskTap();
            }
        }
    });

    module.exports = {};

});
