define(function(require, exports, module) {

    function Tips() {
        this._opts = {
            duration: 1500,
            speed: 300,
            title: '',
            subtitle: '',
        };
    }

    Tips.prototype = {
        show: function(opts) {
            opts = $.extend(true, this._opts, opts);
            var id = new Date().getTime();
            var subtitle = '<span>' + opts.subtitle + '</span>';
            subtitle = (opts.subtitle == '') ? '' : subtitle;
            var title = '<div class="mod-tips" id="' + id + '">' + opts.title + subtitle + '</div>';
            var $tips = $(title);
            var show = false;
            $tips.on('webkitTransitionEnd', function() {
                if (show) {
                    $tips.off().remove();
                    $tips = null;
                } else {
                    show = true;
                    setTimeout(function() {
                        $tips.css('transform', 'translate3d(0, 0, 0)');
                        $tips.css('-webkit-transform', 'translate3d(0, 0, 0)');
                    }, opts.duration);
                }
            });

            $tips.css('-webkit-transition', 'all ' + opts.speed + 'ms');

            $('body').append($tips);
            setTimeout(function() {
                $tips.css('transform', 'translate3d(0, -50px, 0)');
                $tips.css('-webkit-transform', 'translate3d(0, -50px, 0)');
            }, 10);
        },
    };

    Tips.prototype.constructor = Tips;

    module.exports = new Tips();

});
